chiark / gitweb /
699ec6cf8c11109ea35673efcc80662c86a35224
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8
9 t-set-intree
10
11 : ${DGIT_TEST_DEBUG:=-D}
12 export DGIT_TEST_DEBUG
13
14 root=`pwd`
15 troot=$root/tests
16 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
17
18 tmp=$ADTTMP
19 if [ x"$tmp" = x ]; then
20         mkdir -p tests/tmp
21         tmp=tests/tmp/$testname
22         rm -rf $tmp
23         mkdir $tmp
24 fi
25 cd $tmp
26
27 tmp=`pwd`
28
29 t-set-using-tmp
30
31 ln -f $troot/ssh ssh
32
33 mkdir -p $tmp/gnupg
34 cp $troot/gnupg/* $tmp/gnupg
35 chmod go-rw $tmp/gnupg/*
36
37 export DEBCHANGE_VENDOR=dpkg
38
39 mkdir -p $tmp/incoming
40 cat <<END >$tmp/dput.cf
41 [test-dummy]
42 method                  = local
43 incoming                = $tmp/incoming
44 run_dinstall            = 0
45 END
46
47 t-expect-fail () {
48         local mpat="$1"; shift
49
50         local grepper=fgrep
51         case "$mpat" in
52         [A-Z]:*)
53                 case "$mpat" in
54                 E:*)    grepper=egrep   ;;
55                 F:*)    grepper=fgrep   ;;
56                 *)      fail "bad mpat prefix in $mpat";;
57                 esac
58                 mpat=${mpat#[A-Z]:}
59                 ;;
60         esac
61
62         set +o pipefail
63         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
64         local ps="${PIPESTATUS[*]}"
65         set -o pipefail
66
67         case $ps in
68         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
69         *" 0")  ;;
70         *)      fail "tee failed"  ;;
71         esac
72
73         $grepper -e "$mpat" $tmp/t.output ||
74                 fail "error message not found"
75 }
76
77 t-expect-push-fail () {
78         local mpat="$1"; shift
79
80         local triedpush=`git rev-parse HEAD`
81
82         t-reporefs pre-push
83         t-expect-fail "$mpat"  "$@"
84         t-reporefs post-push
85         diff $tmp/show-refs.{pre,post}-push
86
87         t-git-objects-not-present '' $triedpush
88
89         eval "$t_expect_push_fail_hook"
90 }
91
92 t-git-objects-not-present () {
93         # t-git-objects-not-present GITDIR|'' OBJID [...]
94         # specifying '' means the repo for package $p
95         local gitdir="${1-$tmp/git/$p.git}"
96         local obj
97         if ! [ -e "$gitdir" ]; then return; fi
98         for obj in "$@"; do
99                 GIT_DIR=$gitdir \
100                 t-expect-fail 'unable to find' \
101                 git cat-file -t $obj
102         done
103 }
104
105 t-reporefs () {
106         local whichoutput=$1; shift
107         local outputfile="$tmp/show-refs.$whichoutput"
108         (set -e
109          exec >"$outputfile"
110          if test -d $tmp/git/$p.git; then
111                 cd $tmp/git/$p.git
112                 git show-ref |sort
113         fi)
114 }
115
116 t-untar () {
117         local tarfile=$1.tar
118         local edittree=$1.edit
119         if test -d "$edittree"; then
120                 cp -al "$edittree"/* .
121         else
122                 tar xf "$tarfile"
123         fi
124 }
125
126 t-worktree () {
127         rm -rf $p
128         t-untar $troot/worktrees/${p}_$1
129 }
130
131 t-git () {
132         p=$1
133         v=$2
134         mkdir -p $tmp/git
135         local gs=$troot/git-srcs/${p}_$v.git
136         (set -e; cd $tmp/git; t-untar $gs)
137 }
138
139 t-git-none () {
140         mkdir -p $tmp/git
141         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
142 }
143
144 t-has-ancestor () {
145         local now=`git rev-parse HEAD`
146         local ancestor=`git rev-parse $1^{}`
147         local mbase=`git merge-base $ancestor $now`
148         if [ x$mbase != x$ancestor ]; then
149                 fail "not ff $ancestor..$now, $mbase != $ancestor"
150         fi
151 }
152
153 t-prep-newpackage () {
154         p=$1
155         v=$2
156         t-archive-none $p
157         t-git-none
158         t-worktree $v
159         cd $p
160         if ! git show-ref --verify --quiet refs/heads/master; then
161                 git branch -m dgit/sid master
162                 git remote rm dgit
163         fi
164         cd ..
165 }
166
167 t-archive-none () {
168         p=$1
169         mkdir -p $tmp/aq $tmp/mirror/pool/main
170
171         local suite=sid
172
173         >$tmp/aq/package.$suite.$p
174         t-archive-updated $suite $p
175
176         >$tmp/aq/package.new.$p
177         t-archive-updated new $p
178
179         ln -s sid $tmp/aq/dsc_in_suite/unstable
180         cat <<'END' >$tmp/aq/suites
181 [
182    {
183       "archive" : "ftp-master",
184       "codename" : "sid",
185       "components" : [
186          "main",
187          "contrib",
188          "non-free"
189       ],
190       "name" : "unstable",
191       "dakname" : "unstable"
192    }
193 ]
194 END
195 }
196
197 t-archive-updated () {
198         local suite=$1
199         local p=$2
200         local suitedir=$tmp/aq/dsc_in_suite/$suite
201         mkdir -p $suitedir
202         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
203                 use JSON;
204                 use strict;
205                 our @v;
206                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
207                 push @v, {
208                         "version" => "$1",
209                         "sha256sum" => "$2",
210                         "component" => "$3",
211                         "filename" => "$4",
212                 };
213                 END {
214                         print to_json \@v or die $!;
215                 }
216         '
217 }
218
219 t-archive-process-incoming () {
220         local suite=$1
221         mv $tmp/incoming/${p}_${v}[._]* $tmp/mirror/pool/main/
222         t-archive-query "$suite"
223 }
224
225 t-archive-query () {
226         local suite=${1-sid}
227         local dscf=main/${p}_${v}.dsc
228         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
229         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
230         t-archive-updated $suite $p
231 }
232
233 t-archive () {
234         t-archive-none $1
235         v=$2
236         local dscf=${p}_$2.dsc
237         rm -f $tmp/mirror/pool/main/${p}_*
238         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
239         t-archive-query
240         rm -rf $tmp/extract
241         mkdir $tmp/extract
242         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
243 }
244
245 t-git-dir-time-passes () {
246         touch -d 'last year' $tmp/git/$p.git
247 }
248
249 t-git-dir-check () {
250         local gitdir=$tmp/git/$p.git
251         case "$1" in
252         enoent)
253                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
254                 return
255                 ;;
256         public) wantstat='7[75]5' ;;
257         secret) wantstat='7[70]0' ;;
258         *)      fail "$1 t-git-dir-check ?" ;;
259         esac
260         gotstat=`stat -c%a $gitdir`
261         case "$gotstat" in
262         *$wantstat) return ;;
263         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
264         esac
265 }
266
267 t-rm-dput-dropping () {
268         rm -f $tmp/${p}_${v}_*.upload
269 }
270
271 t-dgit () {
272         local dgit=${DGIT_TEST-dgit}
273         pwd
274         : '
275 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
276         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
277                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
278                 -k39B13D8A "$@"
279         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
280 '
281 }
282
283 t-diff-nogit () {
284         diff --exclude=.git --exclude=.pc -ruN $*
285 }
286
287 t-cloned-fetched-good () {
288         t-diff-nogit ../extract/$p-${v%-*} .
289         t-clean-on-branch dgit/sid
290         t-refs-same-start
291         t-refs-same \
292                 refs/heads/dgit/sid \
293                 refs/remotes/dgit/dgit/sid
294         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
295 }
296
297 t-output () {
298         printf "%s\n" "$1" >$tmp/t.want
299         shift
300         "$@" >$tmp/t.got
301         diff $tmp/t.want $tmp/t.got
302 }
303
304 t-clean-on-branch () {
305         t-output "## $1" git status -b --porcelain
306 }
307
308 t-git-get-ref-exact () {
309         local ref=$1
310         # does not dereference, unlike t-git-get-ref
311         case "$ref" in
312         refs/*) ;;
313         *) fail "t-git-get-ref-exact bad $ref" ;;
314         esac
315         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
316 }
317
318 t-git-get-ref () {
319         local ref=$1
320         case "$ref" in
321         refs/*) ;;
322         *) fail "t-git-get-ref bad $ref" ;;
323         esac
324         (git show-ref -d $1 || test $? = 1) | perl -ne '
325                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
326                 END { print "$x\n" if length $x; }
327         '
328 }
329
330 t-ref-same () {
331         local name="$1"
332         local val=`t-git-get-ref $name`
333         t-ref-same-val "$name" $val
334 }
335
336 t-ref-head () {
337         local val=`git rev-parse HEAD`
338         t-ref-same-val HEAD $val
339 }
340
341 t-ref-same-val () {
342         local name="$1"
343         local val=$2
344         case "$t_ref_val" in
345         '')             ;;
346         "$val")         ;;
347         *)              fail "ref varies: $name: $val != $t_ref_val" ;;
348         esac
349         t_ref_val="$val"
350 }
351
352 t-refs-same-start () {
353         t_ref_val=''
354 }
355
356 t-refs-same () {
357         local g
358         for g in $*; do
359                 t-ref-same $g
360         done
361 }
362
363 t-refs-notexist () {
364         local val
365         for g in $*; do
366                 val=`t-git-get-ref $g`
367                 if [ "x$val" != x ]; then
368                         fail "ref $g unexpectedly exists ($val)"
369                 fi
370         done
371 }
372
373 t-v-tag () {
374         echo refs/tags/test-dummy/${v//\~/_}
375 }
376
377 t-pushed-good () {
378         local branch=$1
379         t-ref-dsc-dgit
380         t-refs-same \
381                 refs/heads/$branch \
382                 `t-v-tag` \
383                 refs/remotes/dgit/dgit/sid
384         t-refs-notexist \
385                 refs/heads/dgit/unstable \
386                 refs/remotes/dgit/dgit/unstable
387         (set -e; cd $tmp/git/$p.git
388          t-refs-same \
389                 refs/dgit/sid \
390                 `t-v-tag`
391          t-refs-notexist \
392                 refs/dgit/unstable
393         )
394         git verify-tag `t-v-tag`
395 }
396
397 t-822-field () {
398         local file=$1
399         local field=$2
400         perl -e '
401                 use Dpkg::Control::Hash;
402                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
403                 $h->parse(\*STDIN,"'"$file"'");
404                 my $val = $h->{"'$field'"},"\n";
405                 die "'"$file $field"'" unless defined $val;
406                 print $val,"\n";
407         ' <$file
408 }
409
410 t-stunt-envvar () {
411         local var=$1
412         local tstunt=$2
413         eval '
414                 case "'$var'" in
415                 "$tstunt:"*)    ;;
416                 *":$tstunt:"*)  ;;
417                 *)              '$var'="$tstunt:$'$var'" ;;
418                 esac
419         '
420 }
421
422 t-tstunt () {
423         local tstunt=$tmp/tstunt
424         t-stunt-envvar PATH $tstunt
425         t-stunt-envvar PERLLIB $tstunt
426         local f
427         for f in "$@"; do
428                 f="./$f"
429                 local d="$tstunt/${f%/*}"
430                 mkdir -p $d
431                 ln -sf "$troot/tstunt/$f" "$d"/.
432         done
433 }
434
435 t-tstunt-parsechangelog () {
436         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
437 }
438
439 t-prep-mergechangelogs () {
440         local b=merge.dpkg-mergechangelogs
441         git config $b.name 'debian/changelog merge driver'
442         git config $b.driver 'dpkg-mergechangelogs -m %O %A %B %A'
443         mkdir -p .git/info
444         echo >>.git/info/attributes \
445                 'debian/changelog merge=dpkg-mergechangelogs'
446 }
447
448 t-ref-dsc-dgit () {
449         local dsc=${p}_${v}.dsc
450         local val=`t-822-field $tmp/incoming/$dsc Dgit`
451         perl -e '$_=shift @ARGV; die "$dsc Dgit $_ ?" unless m/^\w+\b/;' "$val"
452         t-ref-same-val $dsc "$val"
453 }
454
455 t-apply-diff () {
456         local v1=$1
457         local v2=$2
458         (cd $troot/pkg-srcs;
459          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
460          | patch -p1 -u
461 }
462
463 t-commit () {
464         local msg=$1
465         v=${2-1.$revision}
466         dch -v$v --distribution unstable "$1"
467         git add debian/changelog
468         debcommit
469         revision=$(( ${revision-0} + 1 ))
470 }
471
472 t-git-config () {
473         git config --global "$@"
474 }
475
476 t-drs () {
477         export DGIT_TEST_TROOT=$troot
478  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
479  t-git-config dgit-distro.test-dummy.git-check true
480  t-git-config dgit-distro.test-dummy.git-create true
481         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
482         cp $troot/suites $tmp/.
483
484         drs_dispatch=$tmp/distro=test-dummy
485         mkdir $drs_dispatch
486
487         if [ "x$DGIT_TEST_INTREE" != x ]; then
488                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
489         fi
490
491         ln -sf $tmp/git $drs_dispatch/repos
492         ln -sf $tmp/suites $tmp/dm.txt $drs_dispatch/
493         mkdir -p $drs_dispatch/keyrings
494         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
495         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
496         ln -sf /bin/true $drs_dispatch/policy-hook
497 }
498
499 t-dsd () {
500         t-drs
501  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
502  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
503  t-git-config dgit-distro.test-dummy.git-create true
504  t-git-config dgit-distro.test-dummy.git-url \
505                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
506
507  t-git-config dgit-distro.test-dummy.diverts.drs /drs
508  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
509  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
510  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
511  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
512
513         echo 'no-such-package* drs' >$drs_dispatch/diverts
514 }
515
516 t-policy-admin () {
517         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
518 }
519
520 t-policy-nonexist () {
521         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
522 }
523
524 t-policy () {
525         local policyhook=$1
526         policyhook=${DGIT_INFRA_PFX}$policyhook
527         case $policyhook in
528         */*)    ;;
529         *)      policyhook=`type -P $policyhook` ;;
530         esac
531         ln -sf "$policyhook" $drs_dispatch/policy-hook
532 }
533
534 t-debpolicy () {
535         t-dsd
536         t-policy dgit-repos-policy-debian
537
538         mkdir $tmp/git
539         t-policy-admin create-db
540 }
541
542 t-policy-periodic () {
543         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
544                 test-dummy $drs_dispatch '' --cron
545 }
546
547 t-chain-test () {
548         local ct=$1
549         local d=${0%/*}
550         cd $root
551         export DGIT_TEST_TESTNAME="$testname"
552         export ADTTMP=$tmp
553         exec "$d/$ct"
554 }       
555
556 t-alt-test () {
557         local t=${0##*/}
558         t-${t%%-*}
559         t-chain-test "${t#*-}"
560 }